-- NilObject.lua

local NilObject = {}
local nil_metatable = {}

-- functions
function NilObject.New()
	local instance = {}
	setmetatable(instance, nil_metatable)
	return instance
end
function NilObject:NilFunction()
	return self
end

-- metatable
nil_metatable.__index = NilObject.NilFunction
nil_metatable.__add = NilObject.NilFunction
nil_metatable.__sub = NilObject.NilFunction
nil_metatable.__mul = NilObject.NilFunction
nil_metatable.__div = NilObject.NilFunction
nil_metatable.__mod = NilObject.NilFunction
nil_metatable.__pow = NilObject.NilFunction
nil_metatable.__unm = NilObject.NilFunction
nil_metatable.__concat = NilObject.NilFunction
nil_metatable.__len = NilObject.NilFunction
nil_metatable.__eq = NilObject.NilFunction
nil_metatable.__lt = NilObject.NilFunction
nil_metatable.__le = NilObject.NilFunction
nil_metatable.__call = NilObject.NilFunction

return NilObject
