-- Reflection.lua

local Reflection = {}
local Reflection_metatable = {}

-- static
function Reflection.New(c_sharp_reflection)
	local instance = { c_sharp_reflection_ = c_sharp_reflection }
	setmetatable(instance, Reflection_metatable)
	return instance
end

-- metatable
function Reflection_metatable.__index(t, key)
	return t.c_sharp_reflection_:Get(key)
end
function Reflection_metatable.__newindex(t, key, value)
	return t.c_sharp_reflection_:Set(key, value)
end

return Reflection
